"use strict";
/**
 * Fetch polyfill for node
 * @internal
 * @packageDocumentation
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isNode_1 = __importDefault(require("./util/isNode"));
const glob = isNode_1.default ? global : window;
/** @internal */
let fetch = glob.fetch;
if (!fetch) {
    try {
        fetch = require('node-fetch');
    }
    catch (e) {
        throw new Error('critical: gd.js cannot function without a fetch polyfill; node-fetch not installed and no fetch polyfill was provided. Please install node-fetch to resolve the issue.');
    }
}
exports.default = fetch.bind(glob);
