"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Polyfilling for unsupported platforms
 * @internal
 * @packageDocumentation
 */
const isNode_1 = __importDefault(require("./util/isNode"));
if (isNode_1.default) {
    // Node.js
    if (!global.fetch) {
        try {
            global.fetch = require('node-fetch');
        }
        catch (e) {
            // node-fetch not installed
            throw new Error('critical: gd.js cannot function without a fetch polyfill; node-fetch not installed and global.fetch not set. Please install node-fetch or set your own custom polyfill into global.fetch.');
        }
    }
    global.atob = (str) => Buffer.from(str, 'base64').toString();
    global.btoa = (str) => Buffer.from(str).toString('base64');
    global.URL = require('url').URL;
    global.URLSearchParams = require('url').URLSearchParams;
    try {
        global.Worker = require('worker_threads').Worker;
    }
    catch (e) { }
}
else if (typeof fetch === 'undefined') {
    // Old browser
    throw new Error("critical: gd.js cannot function without the fetch API, and it doesn't seem \
    to exist in the current environment. Try polyfilling it with whatwg-fetch.");
}
