"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.gdDecodeBase64 = exports.gdEncodeBase64 = void 0;
const isNode_1 = __importDefault(require("../isNode"));
const encdec_1 = require("./encdec");
/**
 * Encode a string in Geometry Dash server-compatible Base64
 * @param str The string to encode in Geometry Dash Base64
 * @returns The Geometry Dash Base64 string
 * @internal
 */
exports.gdEncodeBase64 = isNode_1.default
    ? (str) => Buffer.from(str).toString('base64')
    : encdec_1.gdEncodeBase64;
/**
 * Decode a string from Geometry Dash server-compatible Base64
 * @param str The string to decode from Geometry Dash Base64
 * @returns The original, unencoded string
 * @internal
 */
exports.gdDecodeBase64 = isNode_1.default
    ? (str) => Buffer.from(str, 'base64').toString()
    : encdec_1.gdDecodeBase64;
