"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isNode_1 = __importDefault(require("./isNode"));
const crypto_1 = require("./crypto");
/**
 * Compressed version of https://github.com/101arrowz/tiny-inflate
 * @internal
 */
const workerInflate = `
var TINF_OK=0,TINF_DATA_ERROR=-3;function Tree(){this.table=new Uint16Array(16);this.trans=new Uint16Array(288)}function Data(a,e){this.source=a;this.bitcount=this.tag=this.sourceIndex=0;this.dest=e;this.destLen=0;this.ltree=new Tree;this.dtree=new Tree}
var sltree=new Tree,sdtree=new Tree,length_bits=new Uint8Array(30),length_base=new Uint16Array(30),dist_bits=new Uint8Array(30),dist_base=new Uint16Array(30),clcidx=new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),code_tree=new Tree,lengths=new Uint8Array(320);function tinf_build_bits_base(a,e,b,d){var c;for(c=0;c<b;++c)a[c]=0;for(c=0;c<30-b;++c)a[c+b]=c/b|0;b=d;for(c=0;30>c;++c)e[c]=b,b+=1<<a[c]}
function tinf_build_fixed_trees(a,e){var b;for(b=0;7>b;++b)a.table[b]=0;a.table[7]=24;a.table[8]=152;a.table[9]=112;for(b=0;24>b;++b)a.trans[b]=256+b;for(b=0;144>b;++b)a.trans[24+b]=b;for(b=0;8>b;++b)a.trans[168+b]=280+b;for(b=0;112>b;++b)a.trans[176+b]=144+b;for(b=0;5>b;++b)e.table[b]=0;e.table[5]=32;for(b=0;32>b;++b)e.trans[b]=b}var offs=new Uint16Array(16);
function tinf_build_tree(a,e,b,d){var c,f;for(c=0;16>c;++c)a.table[c]=0;for(c=0;c<d;++c)a.table[e[b+c]]++;for(c=f=a.table[0]=0;16>c;++c)offs[c]=f,f+=a.table[c];for(c=0;c<d;++c)e[b+c]&&(a.trans[offs[e[b+c]]++]=c)}function tinf_getbit(a){a.bitcount--||(a.tag=a.source[a.sourceIndex++],a.bitcount=7);var e=a.tag&1;a.tag>>>=1;return e}
function tinf_read_bits(a,e,b){if(!e)return b;for(;24>a.bitcount;)a.tag|=a.source[a.sourceIndex++]<<a.bitcount,a.bitcount+=8;var d=a.tag&65535>>>16-e;a.tag>>>=e;a.bitcount-=e;return d+b}function tinf_decode_symbol(a,e){for(;24>a.bitcount;)a.tag|=a.source[a.sourceIndex++]<<a.bitcount,a.bitcount+=8;var b=0,d=0,c=0,f=a.tag;do d=2*d+(f&1),f>>>=1,++c,b+=e.table[c],d-=e.table[c];while(0<=d);a.tag=f;a.bitcount-=c;return e.trans[b+d]}
function tinf_decode_trees(a,e,b){var d;var c=tinf_read_bits(a,5,257);var f=tinf_read_bits(a,5,1);var g=tinf_read_bits(a,4,4);for(d=0;19>d;++d)lengths[d]=0;for(d=0;d<g;++d){var h=tinf_read_bits(a,3,0);lengths[clcidx[d]]=h}tinf_build_tree(code_tree,lengths,0,19);for(g=0;g<c+f;)switch(d=tinf_decode_symbol(a,code_tree),d){case 16:h=lengths[g-1];for(d=tinf_read_bits(a,2,3);d;--d)lengths[g++]=h;break;case 17:for(d=tinf_read_bits(a,3,3);d;--d)lengths[g++]=0;break;case 18:for(d=tinf_read_bits(a,7,11);d;--d)lengths[g++]=
0;break;default:lengths[g++]=d}tinf_build_tree(e,lengths,0,c);tinf_build_tree(b,lengths,c,f)}function tinf_inflate_block_data(a,e,b){for(;;){var d=tinf_decode_symbol(a,e);if(256===d)return TINF_OK;if(256>d)a.dest[a.destLen++]=d;else{var c;d-=257;d=tinf_read_bits(a,length_bits[d],length_base[d]);var f=tinf_decode_symbol(a,b);for(c=f=a.destLen-tinf_read_bits(a,dist_bits[f],dist_base[f]);c<f+d;++c)a.dest[a.destLen++]=a.dest[c]}}}
function tinf_inflate_uncompressed_block(a){for(var e,b;8<a.bitcount;)a.sourceIndex--,a.bitcount-=8;e=a.source[a.sourceIndex+1];e=256*e+a.source[a.sourceIndex];b=a.source[a.sourceIndex+3];b=256*b+a.source[a.sourceIndex+2];if(e!==(~b&65535))return TINF_DATA_ERROR;for(a.sourceIndex+=4;e;--e)a.dest[a.destLen++]=a.source[a.sourceIndex++];a.bitcount=0;return TINF_OK}
function tinf_readle(a,e,b){for(var d=0,c=0;c<b;++c){var f=a[e+c];if("undefined"===typeof f)throw Error("out of bounds");d+=f<<8*c}return d}
function tinf_inflate_base(a,e){var b=new Data(a,e);do{var d=tinf_getbit(b);var c=tinf_read_bits(b,2,0);switch(c){case 0:c=tinf_inflate_uncompressed_block(b);break;case 1:c=tinf_inflate_block_data(b,sltree,sdtree);break;case 2:tinf_decode_trees(b,b.ltree,b.dtree);c=tinf_inflate_block_data(b,b.ltree,b.dtree);break;default:c=TINF_DATA_ERROR}if(c!==TINF_OK)throw Error("Data error");}while(!d);return b.destLen<b.dest.length?"function"===typeof b.dest.slice?b.dest.slice(0,b.destLen):b.dest.subarray(0,
b.destLen):b.dest}function tinf_inflate(a,e){return e?tinf_inflate_base(a,e):new Uint8Array(tinf_inflate_base(a,[]))}function tinf_gunzip(a,e){var b=a.length;if(18>b||31!==a[0]||139!==a[1]||8!==a[2])throw Error("invalid gzip data");var d=a[3],c=10;if(d&4)try{c+=tinf_readle(a,c,2)+2}catch(g){throw Error("invalid gzip data");}for(var f=(d>>3&1)+(d>>4&1);0<f;f-=0===a[c++]);c+=d&2;e||(e=new Uint8Array(tinf_readle(a,b-4,4)));return tinf_inflate_base(a.subarray(c,b-8),e)}
function tinf_decompress(a,e){if(6>a.length||a[0]&1||7<a[0]>>4)throw Error("invalid zlib data");if(a[1]&32)throw Error("invalid zlib data: dictionaries not supported");return tinf_inflate(a.subarray(2,-4),e)}function tinf_uncompress(a,e){return 31===a[0]&&139===a[1]?tinf_gunzip(a,e):a[0]&1||7<a[0]>>4?tinf_inflate(a,e):tinf_decompress(a,e)}tinf_uncompress.inflate=tinf_inflate;tinf_uncompress.gunzip=tinf_gunzip;tinf_uncompress.decompress=tinf_decompress;tinf_build_fixed_trees(sltree,sdtree);
tinf_build_bits_base(length_bits,length_base,4,3);tinf_build_bits_base(dist_bits,dist_base,2,1);length_bits[28]=0;length_base[28]=258;`;
eval(workerInflate);
/**
 * Decompresses data of an arbitrary type from the Geometry Dash servers
 * @param data The Base64, compressed data to decompress
 * @returns The source string data
 * @internal
 */
const decompress = async (data) => {
    const rawBytes = isNode_1.default
        ? Buffer.from(data, 'base64')
        : new Uint8Array(crypto_1.gdDecodeBase64(data)
            .split('')
            .map(str => str.charCodeAt(0)));
    let resultBytes;
    if (typeof Worker !== 'undefined') {
        resultBytes = await new Promise((res, rej) => {
            if (isNode_1.default) {
                const NodeWorker = Worker;
                const worker = new NodeWorker(workerInflate +
                    `
        var { workerData, parentPort } = require('worker_threads');
        parentPort.postMessage(tinf_uncompress(workerData));`, {
                    workerData: rawBytes,
                    eval: true
                });
                worker.on('message', res);
                worker.on('error', rej);
                worker.on('exit', code => {
                    if (code !== 0)
                        rej();
                });
            }
            else {
                const worker = new Worker(URL.createObjectURL(new Blob([
                    workerInflate +
                        `
            addEventListener('message', ev => {
              var decompressed = tinf_uncompress(ev.data);
              postMessage(decompressed, [decompressed.buffer]);
            });`
                ], { type: 'text/javascript' })));
                worker.addEventListener('message', ev => res(ev.data));
                worker.addEventListener('error', ev => rej(ev.error));
                worker.postMessage(rawBytes, [rawBytes.buffer]);
            }
        });
    }
    else {
        resultBytes = tinf_uncompress(rawBytes);
    }
    let out = '';
    for (const byte of resultBytes)
        out += String.fromCharCode(byte);
    return out;
};
exports.default = decompress;
