"use strict";
/**
 * Zlib
 * @internal
 * @packageDocumentation
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decompress = void 0;
const isNode_1 = __importDefault(require("./isNode"));
const flate_1 = require("./flate");
/**
 * Decompress data of an arbitrary format
 * @param dat The data to decompress
 * @returns The decompressed data
 * @internal
 */
exports.decompress = isNode_1.default
    ? (dat) => {
        const { inflateRaw, gunzip, inflate } = require('zlib');
        return new Promise((res, rej) => {
            const cb = (err, dat) => (err ? rej(err) : res(dat));
            if (dat[0] == 31 && dat[1] == 139)
                gunzip(dat, cb);
            else if ((dat[0] & 15) != 8 || dat[0] >> 4 > 7 || ((dat[0] << 8) | dat[1]) % 31)
                inflateRaw(dat, cb);
            else
                inflate(dat, cb);
        });
    }
    : flate_1.decompress;
